const { env, drgWithAttach, environment, environmentFromService } = require('./util');


// Henter fravalgs registrering for en borger
async function GetConsent(attach, identifier) {
    id = 'fgvhr.GetConsent'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: identifier,
        },
        'auth-attributes': { cpr: identifier },
    };
    // await drgWithAttach(attach, body);
    let FGVHRRegisterResponse = await drgWithAttach(attach, body);

    return FGVHRRegisterResponse.body.response.main.Envelope.Body
        .Consent.status.__value
}

// Henter fravalgs registrering borger på vegne af anden borger
async function GetConsentCustody(attach, patientId, custodyCpr) {
    id = 'fgvhr.GetConsent'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: patientId,
        },
        'auth-attributes': { cpr: custodyCpr },
    };
    return await drgWithAttach(attach, body);


}

// Opretter fravalgs registrering for en borger
async function RegisterConsent(attach, identifier) {
    id = 'fgvhr.RegisterConsent'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: identifier,
        },
        'auth-attributes': { cpr: identifier },
    };
    await drgWithAttach(attach, body);
}

// Opretter fravalgs registrering borger på vegne af anden borger
async function RegisterConsentCustody(attach, custodyId, patientId) {
    id = 'fgvhr.RegisterConsent'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: patientId,
        },
        'auth-attributes': { cpr: custodyId },

    };
    return await drgWithAttach(attach, body);
}

// Sletter fravalgs registrering for en borger af en borger
async function DeleteConsent(attach, patientCpr) {
    id = 'fgvhr.DeleteConsent'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: patientCpr,
        },
        'auth-attributes': { cpr: patientCpr },
    };
    await drgWithAttach(attach, body);

}

// Sletter fravalgs registrering for en borger af admin
async function DeleteConsentAdmin(attach, patientCpr, date) {
    id = 'fgvhr.AdminDeleteConsent'
    const body = {
        id: id,
        role: 'test.trinelarsen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: patientCpr,
            signingDate: date
        },
        'auth-attributes': {},
        "chosen-role": {
            type: "NATIONAL_ROLE",
            title: "SpaerAdminR8",
            role: "urn:dk:healthcare:national-federation-role:code:41008:value:SpaerAdminR8",
            authorizationCode: null
        }
    };
    await drgWithAttach(attach, body);
}

async function personLookup(attach, patientCPR) {
    id = 'sces.personLookup.1.0.4'
    const body = {
        id: id,
        role: 'test.drg.foces3',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            PersonCivilRegistrationIdentifier: patientCPR,
        },
        'auth-attributes': {},
    };

    return await drgWithAttach(attach, body);
}

// Opretter fravalgs registrering for en borger af admin
async function RegisterConsentAdmin(attach, identifier, signingDate) {
    id = 'fgvhr.AdminRegisterConsent'
    const body = {
        id: id,
        role: 'test.trinelarsen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            identifier: identifier,
            signingDate: signingDate,
        },
        'auth-attributes': {},
        "chosen-role": {
            "type": "NATIONAL_ROLE",
            "title": "SpearAdminR8",
            "role": "urn:dk:healthcare:national-federation-role:code:41008:value:SpaerAdminR8",
            "authorizationCode": null
        }
    };
    await drgWithAttach(attach, body);
}

module.exports = {
    GetConsent,
    DeleteConsent,
    personLookup,
    RegisterConsent,
    RegisterConsentCustody,
    GetConsentCustody,
    DeleteConsentAdmin,
    RegisterConsentAdmin
};
