const { env, drgWithAttach, environment, environmentFromService } = require('./util');

//dato forsøges at gøres dynamisk ved at have det som input
//Chosen-role tilføjet
async function createBlurring(attach, patientId, endDateTime, CVR) {
    let body;
    id = 'idsas.CreateBlurring'
    if (CVR == "33257872") {
        body = {
            id: id,
            role: 'test.annebonde',
            endpoint: environment(environmentFromService.get(id)),
            fields: {
                patientId: patientId,
                endDateTime: endDateTime,
            },
            'auth-attributes': {},
            "chosen-role": {
                type: 'AUTHORIZATION',
                title: 'læge',
                role: '7170',
                authorizationCode: 'QW013'
            }
        };
    } else if (CVR == "95444960") {
        body = {
            id: id,
            role: 'test.prebenkoebmandsen',
            endpoint: environment(environmentFromService.get(id)),
            fields: {
                patientId: patientId,
                endDateTime: endDateTime,
            },
            'auth-attributes': {},
            "chosen-role": {
                type: "NATIONAL_ROLE",
                title: "SundAssistR2",
                role: "urn:dk:healthcare:national-federation-role:code:41002:value:SundAssistR2"
            }
        };
    }
    return await drgWithAttach(attach, body);
}

async function createBlurringOrganisation(attach, patientId, endDateTime) {
    id = 'idsas.CreateBlurring'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            patientId: patientId,
            endDateTime: endDateTime,
        },
        'auth-attributes': {},
    };
    return await drgWithAttach(attach, body);
}

async function GetBlurredOrganisations(attach, patientId) {
    id = 'idsas.GetBlurredOrganisations'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            patientId: patientId,
        },
        'auth-attributes': {},
    };
    return await drgWithAttach(attach, body);
}

async function GetActiveOrgBlurrings(attach) {
    id = "idsas.ListAllActiveOrgBlurrings"
    const body = {
        id: id,
        role: "test.drg.foces3",
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            NoFieldsTextBox: "true"
        },
        'auth-attributes': {},
        "chosen-role": null
    }
    return await drgWithAttach(attach, body);
}

async function GetActiveOrgBlurringsforCVR(attach) {
    id = "idsas.ListOrgBlurringsForCVR"
    const body = {
        id: id,
        role: "sds.foces",
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            "NoFieldsTextBox": "true"
        },
        "auth-attributes": {},
        "chosen-role": null
    }
    return await drgWithAttach(attach, body);
}


async function createOrgBlurring(attach, bruger, kode, classification) {
    id = "idsas.CreateOrgBlurring"
    const body = {
        id: "idsas.CreateOrgBlurring",
        role: bruger,
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            orgId: kode,
            classification: classification
        },
        "auth-attributes": {},
        "chosen-role": null
    }
    await drgWithAttach(attach, body);
}
module.exports = {
    createBlurring,
    GetBlurredOrganisations,
    createBlurringOrganisation,
    GetActiveOrgBlurrings,
    GetActiveOrgBlurringsforCVR,
    createOrgBlurring
};
