const { env, drgWithAttach, environment, environmentFromService } = require('./util');

async function lookUpRequest(attach, custodyCPR, patientCPR, fromDateTime, toDateTime) {
    id = 'minlog2.lookUpId'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            cprNumber: patientCPR,
            chronologic: 'true',
            fromDateTime: fromDateTime,
            toDateTime: toDateTime,
        },
        'auth-attributes': { cpr: custodyCPR },
    };
    return await drgWithAttach(attach, body);
}

async function requestRegistry(attach, cprNumber, correlationId, userCprNumber, dateTime, orgIdSource, orgId, userRole, criticality, activity, reason) {
    id = 'minlog2.registry'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            cprNumber: cprNumber,
            correlationId: correlationId,
            userCprNumber: userCprNumber,
            dateTime: dateTime,
            orgIdSource: orgIdSource,
            orgId: orgId,
            userRole: userRole,
            criticality: criticality,
            activity: activity,
            reason: reason
        },
        'auth-attributes': {},
    };
    return await drgWithAttach(attach, body);
}

module.exports = {
    lookUpRequest,
    requestRegistry
};