const { env, drgWithAttach, environment, environmentFromService } = require('./util');

async function getConsentRegistration(attach, PatientCPR) {
    id = 'minspaerring.administration.ConsentRegistrationsGet'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            PatientPersonCivilRegistrationIdentifier: PatientCPR,
        },
        'auth-attributes': {
            cpr: PatientCPR,
        },
    };

    let ConsentRegistrations = await drgWithAttach(attach, body);
    return ConsentRegistrations.body.response.main.Envelope.Body
        .ConsentRegistrationsGetResponse.ConsentRegistrations;
}

async function createConsentRegistration(attach, PatientCPR) {
    id = 'minspaerring.administration.ConsentAddConstraint'
    const body = {
        id: id,
        role: 'test.citizen',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            citizenCPR: PatientCPR,
            CitizenCivilRegistrationNumber: PatientCPR,
            positiveConsent: 'false',
            item: 'whatitem',
            organizationIdentifier: '237891000016004',
            includeSubOrganizations: 'true',
            ReferralStartDate: '2021-08-20T14:59:09.590+02:00',
            ReferralEndDate: '2021-08-22T14:59:09.590+02:00',
            validFromDate: '2022-11-12T10:31:09.590+02:00',
            validToDate: '',
        },
        'auth-attributes': {
            cpr: PatientCPR,
        },
    };
    await drgWithAttach(attach, body);
}

module.exports = {
    getConsentRegistration,
    createConsentRegistration,
};
