const { env_nas, drgWithAttach, environment, environmentFromService } = require('./util');

async function destroyNAS(attach, pullPoint) {
    id = 'nas.DestroyPullPoint'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            UrlAddition: pullPoint,
        },
        'auth-attributes': {},
    };
    return await drgWithAttach(attach, body);
}

async function createNAS(attach) {
    id = 'nas.CreatePullPoint'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            ignoreableCheckbox: 'true',
        },
        'auth-attributes': {},
    };

    return await drgWithAttach(attach, body);
}

async function deleteNASIDList(attach, idListName) {
    id = 'nas.DestroyIDList'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            IDListName: idListName,
        },
        'auth-attributes': {},
    };

    return await drgWithAttach(attach, body);
}

async function createNASIDList(
    attach,
    idListName,
    description,
    idType,
    idList
) {
    id = 'nas.CreateIDListRequest'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            IDListName: idListName,
            Description: description,
            IDType: idType,
            IDList: idList,
        },
        'auth-attributes': {},
    };

    return await drgWithAttach(attach, body);
}

async function unsubscribe(attach, subscriptionRef) {
    id = 'nas.Unsubscribe'
    const body = {
        id: id,
        role: 'sds.foces',
        endpoint: environment(environmentFromService.get(id)),
        fields: {
            UrlAddition: subscriptionRef,
        },
        'auth-attributes': {},
    };
    console.log(body.fields);

    return await drgWithAttach(attach, body);
}

module.exports = {
    destroyNAS,
    createNAS,
    deleteNASIDList,
    createNASIDList,
    unsubscribe,
};
