const {
    Before,
    BeforeAll,
    After,
    Given,
    Then,
    When,
} = require('@cucumber/cucumber');
const jq = require('node-jq');
const { expect } = require('../util');
const roles = new Map(require('../../config/roles.json'));


Then('feed indeholder {string} lig med {string}', function (element, responsesvar) {
    element = this.replaceVariables(element);
    responsesvar = this.replaceVariables(responsesvar);

    switch (element) {
        case 'author':
            const authorResponse =
                this.getLastResponse().body.response.main.Envelope
                    .Body.ReplicationResponse.feed.author.name._text;

            expect(responsesvar).to.equal(authorResponse);
            break;
        case 'entry':
            let lengthOfArray;
            const entryResponse =
                this.getLastResponse().body.response.main.Envelope
                    .Body.ReplicationResponse.feed.entry;

            if (entryResponse != undefined) {
                if (entryResponse.length != undefined) {
                    lengthOfArray = entryResponse.length.toString();
                    console.log(1);
                } else {
                    console.log(2);
                    lengthOfArray = '1';
                }
            } else {
                lengthOfArray = '0';
            }
            expect(lengthOfArray).to.equal(responsesvar);
            break;
        case 'title':
            const titleResponse =
                this.getLastResponse().body.response.main.Envelope
                    .Body.ReplicationResponse.feed.title._text;
            expect(responsesvar).to.equal(titleResponse);
            break;
    }
});