const {
    Before,
    BeforeAll,
    After,
    Given,
    Then,
    When,
} = require('@cucumber/cucumber');
const { expect } = require('../util');
const jq = require('node-jq');

When('SORLS-response indeholder {string} lig med {string}', function (variable, value) {
    variable = this.replaceVariables(variable);
    value = this.replaceVariables(value);
    var response = this.getLastResponse().body.response.main.Envelope.Body;
    if (response.GetSorEntityResponse != undefined) {
        response = response.GetSorEntityResponse.SorObject;
    } else if (response.SorShakMapResponse != undefined) {
        response = response.SorShakMapResponse.SorShakMapResp;
    }

    switch (variable) {
        case 'SorId':
            if (response.SorIdentifier != undefined) {
                expect(response.SorIdentifier._text).to.eql(value)
            } else if (response.SorId != undefined) {
                expect(response.SorId._text).to.eql(value)
            }
            break;
        case 'SorInstitutionOwnerSorId':
            if (response.SorInstitutionOwnerSorId != undefined) {
                expect(response.SorInstitutionOwnerSorId._text).to.eql(value)
            } else if (response.InstitutionOwnerSorId != undefined) {
                expect(response.InstitutionOwnerSorId._text).to.eql(value)
            }
            break;
        default:
            expect(response[variable]._text).to.eql(value)
            break;
    }
});

When('der findes {int} shaktilSOR mapninger', function (amount) {
    const response = this.getLastResponse().body.response.main.Envelope.Body.ShakSorMapResponse.ShakSorMapResp;
    if (Array.isArray(response)) {
        expect(response.length).to.eql(amount)
    } else {
        expect(1).to.eql(amount)
    }
});

When('ShaktilSOR-respons indeholder {string} lig med {string}', async function (variable, value) {
    const response = this.getLastResponse().body.response.main.Envelope.Body.ShakSorMapResponse.ShakSorMapResp;
    value = this.replaceVariables(value);
    var contains = false;
    switch (variable) {
        case 'SorId':
            if (Array.isArray(response)) {
                response.forEach(map => {
                    if (map.SorId._text == value || map.ShakId._text == value) {
                        contains = true;
                    }
                })
                expect(contains).to.eql(true);
            } else {
                expect(response.SorId._text).to.eql(value);
            }
            break;
        case 'ShakId':
            if (Array.isArray(response)) {
                response.forEach(map => {
                    expect(map.ShakId._text).to.eql(value);
                })
            } else {
                expect(response.ShakId._text).to.eql(value);
            }
            break;
        default:
            throw new Error(`Unknown element "${variable}"`);
    }
});