const {
    Given,
    Then,
    When,
} = require('@cucumber/cucumber');
const { getWsdlWithAttach } = require('../../dataaccess/util');
const { expect } = require('../util');
const fs = require('fs/promises');

Given('En WSDL-URL {string} og en fil med den forventede WSDL {string}', function (wsdlUrl, wsdlFile) {
    this.wsdlUrl = wsdlUrl;
    this.wsdlFile = wsdlFile;
});

When('WSDL hentes og den forventede WSDL læses',
    { timeout: -1 },
    async function () {
        this.retrievedWsdl = (await getWsdlWithAttach(this.wsdlUrl, this.attach)).text;
        this.storedWsdl = await fs.readFile(`${__dirname}/known-wsdl/${this.wsdlFile}`, 'utf8');
    });

Then('Skal den hentede WSDL matche den forventede WSDL', function () {
    expect(this.retrievedWsdl).to.eql(this.storedWsdl);
});
